VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "TrueRandom Test"
   ClientHeight    =   7170
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   7545
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   478
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   503
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame frameSettings 
      Caption         =   "Settings:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3015
      Left            =   3720
      TabIndex        =   5
      Top             =   2160
      Width           =   3615
      Begin VB.PictureBox picSettings 
         BorderStyle     =   0  'None
         Height          =   2655
         Left            =   120
         ScaleHeight     =   177
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   225
         TabIndex        =   10
         Top             =   240
         Width           =   3375
         Begin VB.ComboBox cmbService 
            Height          =   315
            Left            =   1440
            Style           =   2  'Dropdown List
            TabIndex        =   15
            Top             =   210
            Width           =   1815
         End
         Begin VB.TextBox txtBufferLenght 
            Height          =   285
            Left            =   1440
            TabIndex        =   14
            Text            =   "128"
            Top             =   570
            Width           =   1815
         End
         Begin VB.TextBox txtBufferAccuracy 
            Height          =   285
            Left            =   1440
            TabIndex        =   13
            Text            =   "2"
            Top             =   930
            Width           =   1815
         End
         Begin VB.TextBox txtSpeed 
            Height          =   285
            Left            =   1440
            TabIndex        =   12
            Text            =   "100"
            Top             =   1290
            Width           =   1815
         End
         Begin VB.TextBox txtMultiplier 
            Height          =   285
            Left            =   1440
            TabIndex        =   11
            Text            =   "10000"
            Top             =   1650
            Width           =   1815
         End
         Begin VB.Label lblService 
            Caption         =   "S&ervice:"
            Height          =   255
            Left            =   120
            TabIndex        =   21
            Top             =   240
            Width           =   1215
         End
         Begin VB.Label lblBufferLenght 
            Caption         =   "B&uffer length:"
            Height          =   255
            Left            =   120
            TabIndex        =   20
            Top             =   585
            Width           =   975
         End
         Begin VB.Label lblBufferAccurecy 
            Caption         =   "B&uffer accuracy:"
            Height          =   255
            Left            =   120
            TabIndex        =   19
            Top             =   945
            Width           =   1215
         End
         Begin VB.Label lblSpeed 
            Caption         =   "S&peed:"
            Height          =   255
            Left            =   120
            TabIndex        =   18
            Top             =   1305
            Width           =   1215
         End
         Begin VB.Label lblMultiplier 
            Caption         =   "&Multiplier:"
            Height          =   255
            Left            =   120
            TabIndex        =   17
            Top             =   1665
            Width           =   1215
         End
         Begin VB.Label lblDescription 
            Height          =   495
            Left            =   120
            TabIndex        =   16
            Top             =   2130
            Width           =   3135
         End
      End
   End
   Begin VB.CommandButton cmdUpdate 
      Caption         =   "&Update"
      Height          =   375
      Left            =   6120
      TabIndex        =   4
      Top             =   5400
      Width           =   1215
   End
   Begin VB.CommandButton cmdStop 
      Caption         =   "S&top"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4920
      TabIndex        =   3
      Top             =   5400
      Width           =   1215
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "&Start"
      Height          =   375
      Left            =   3720
      TabIndex        =   2
      Top             =   5400
      Width           =   1215
   End
   Begin VB.Frame statStatus 
      Caption         =   "Status:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1695
      Left            =   3720
      TabIndex        =   1
      Top             =   240
      Width           =   3615
      Begin VB.PictureBox picStatus 
         BorderStyle     =   0  'None
         Height          =   1335
         Left            =   120
         ScaleHeight     =   89
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   225
         TabIndex        =   6
         Top             =   240
         Width           =   3375
         Begin VB.Label lblAverage 
            Caption         =   "&Average: "
            Height          =   255
            Left            =   120
            TabIndex        =   9
            Top             =   600
            Width           =   2655
         End
         Begin VB.Label lblNumbers 
            Caption         =   "&Numbers: "
            Height          =   255
            Left            =   120
            TabIndex        =   8
            Top             =   240
            Width           =   2775
         End
         Begin VB.Label lblBufferStatus 
            Caption         =   "&Buffer:"
            Height          =   255
            Left            =   120
            TabIndex        =   7
            Top             =   960
            Width           =   2775
         End
      End
   End
   Begin VB.ListBox lstNumbers 
      Height          =   6885
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3375
   End
   Begin VB.Timer tmrPrint 
      Left            =   3720
      Top             =   5880
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Used to enable XP themes
Private Declare Sub InitCommonControls Lib "comctl32.dll" ()

' Our random class
Public TrueRnd As New clsTrueRnd

Private Sub Form_Initialize()

    ' Avoid strage error messages in conjunction with the manifest-file
    InitCommonControls

End Sub

Private Sub Form_Load()

    ' Load services and download numbers
    TrueRnd.LoadServices App.Path & "\Services.xml"

    ' Update the listbox
    AppendServices cmbService, TrueRnd

End Sub

Private Sub cmbService_Change()
    
    ' Update the service
    TrueRnd.CurrentService = cmbService.ListIndex + 1

    ' Auto-set the buffer lenght and update description
    txtBufferLenght.Text = TrueRnd.ServiceMax(TrueRnd.CurrentService)
    lblDescription.Caption = TrueRnd.ServiceDescription(TrueRnd.CurrentService)

End Sub

Private Sub cmbService_Click()

    ' Update all
    cmbService_Change

End Sub

Private Sub cmdStart_Click()

    ' Update the buffer
    cmdUpdate_Click

    ' Initiate the printing
    tmrPrint.Interval = Val(txtSpeed)

    ' Enable/disable controls
    cmdStart.Enabled = False
    cmdStop.Enabled = True
    frameSettings.Enabled = False

End Sub

Private Sub cmdStop_Click()

    ' Stop the printing
    tmrPrint.Interval = 0

    ' Enable/disable controls
    cmdStart.Enabled = True
    cmdStop.Enabled = False
    frameSettings.Enabled = True

End Sub

Private Sub cmdUpdate_Click()

    ' Update the buffer
    TrueRnd.UpdateBuffer False

End Sub

Public Sub AppendServices(cmbBox As ComboBox, oRnd As clsTrueRnd)

    Dim Tell As Long
    
    ' Clear listbox
    cmbBox.Clear
    
    ' Add all services to the listbox
    For Tell = 1 To oRnd.ServiceCount
    
        ' Add service
        cmbBox.AddItem oRnd.ServiceName(Tell)
    
    Next

    ' Select the correct item
    cmbService.ListIndex = oRnd.CurrentService - 1

End Sub

Private Sub tmrPrint_Timer()

    Dim Tell As Long, lngNum As Long

    ' Print a random number
    lstNumbers.AddItem Fix(TrueRnd.RandomNumber * Val(txtMultiplier))
    lstNumbers.ListIndex = lstNumbers.ListCount - 1

    ' Update the status information
    lblNumbers.Caption = "&Numbers: " & lstNumbers.ListCount
    lblBufferStatus.Caption = "&Buffer:    " & Int(TrueRnd.BufferUsed * 100) & "%"

    ' Sum all the items
    For Tell = 0 To lstNumbers.ListCount - 1
        lngNum = lngNum + lstNumbers.List(Tell)
    Next
    
    ' Show the average of all the numbers
    lblAverage.Caption = "&Average: " & lngNum / lstNumbers.ListCount

End Sub

Private Sub txtBufferAccuracy_Change()

    ' Set the buffer accurecy
    TrueRnd.BufferAccuracy = txtBufferAccuracy

End Sub

Private Sub txtBufferLenght_Change()

    ' Set the buffer lenght
    TrueRnd.BufferLenght = Val(txtBufferLenght)

End Sub
